> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gp.scale.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Test Case Results

> ### Description
Lists all test case results accessible to the user.

### Details
This API can be used to list test case results. If a user has access to multiple accounts, all test case results from all accounts the user is associated with will be returned.



## OpenAPI

````yaml https://app.stainlessapi.com/api/spec/documented/sgp/openapi.yml get /v4/evaluations/{evaluation_id}/test-case-results
openapi: 3.1.0
info:
  title: EGP API V4
  description: >-
    This is the parent API for all EGP APIs. If you are looking for the EGP API,
    please go to https://api.egp.scale.com/docs.
  contact:
    name: Scale Generative AI Platform
    url: https://scale.com/genai-platform
  version: 0.1.0
servers:
  - url: https://api.egp.scale.com
security: []
tags:
  - name: Models
    description: Model API.
paths:
  /v4/evaluations/{evaluation_id}/test-case-results:
    get:
      tags:
        - Evaluations
      summary: List Test Case Results
      description: >-
        ### Description

        Lists all test case results accessible to the user.


        ### Details

        This API can be used to list test case results. If a user has access to
        multiple accounts, all test case results from all accounts the user is
        associated with will be returned.
      operationId: GET-V4-/evaluations/{evaluation_id}/test-case-results
      parameters:
        - name: evaluation_id
          in: path
          required: true
          schema:
            type: string
            title: Evaluation Id
        - name: view
          in: query
          required: false
          schema:
            anyOf:
              - type: array
                items:
                  $ref: '#/components/schemas/TestCaseResultViewsOptions'
              - type: 'null'
            title: View
        - name: page
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            description: >-
              Page number for pagination to be returned by the given endpoint.
              Starts at page 1
            default: 1
            title: Page
          description: >-
            Page number for pagination to be returned by the given endpoint.
            Starts at page 1
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            maximum: 10000
            minimum: 1
            description: >-
              Maximum number of artifacts to be returned by the given endpoint.
              Defaults to 100 and cannot be greater than 10k.
            default: 100
            title: Limit
          description: >-
            Maximum number of artifacts to be returned by the given endpoint.
            Defaults to 100 and cannot be greater than 10k.
        - name: include_archived
          in: query
          required: false
          schema:
            type: boolean
            default: false
            title: Include Archived
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedTestCaseResultResponseWithViews'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from scale_gp import SGPClient

            client = SGPClient(
                api_key=os.environ.get("SGP_API_KEY"),  # This is the default and can be omitted
            )
            page = client.evaluations.test_case_results.list(
                evaluation_id="evaluation_id",
            )
            page = page.items[0]
            print(page)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/stainless-sdks/sgp-go\"\n\t\"github.com/stainless-sdks/sgp-go/option\"\n)\n\nfunc main() {\n\tclient := sgp.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.Evaluations.TestCaseResults.List(\n\t\tcontext.TODO(),\n\t\t\"evaluation_id\",\n\t\tsgp.EvaluationTestCaseResultListParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
components:
  schemas:
    TestCaseResultViewsOptions:
      type: string
      enum:
        - AnnotationResults
        - AuditTasks
        - CustomMetrics
        - Metrics
        - Task
        - TestCaseVersion
        - Trace
      title: TestCaseResultViewsOptions
    PaginatedTestCaseResultResponseWithViews:
      properties:
        items:
          items:
            $ref: '#/components/schemas/TestCaseResultResponseWithViews'
          type: array
          title: Items
          description: The data returned for the current page.
        total_item_count:
          type: integer
          title: Total Item Count
          description: The total number of items of the query
        current_page:
          type: integer
          title: Current Page
          description: The current page number.
        items_per_page:
          type: integer
          title: Items Per Page
          description: The number of items per page.
      type: object
      required:
        - items
        - total_item_count
        - current_page
        - items_per_page
      title: PaginatedTestCaseResultResponseWithViews
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    TestCaseResultResponseWithViews:
      oneOf:
        - $ref: '#/components/schemas/GenerationTestCaseResultResponseWithViews'
        - $ref: '#/components/schemas/FlexibleTestCaseResultResponseWithViews'
      title: TestCaseResultResponseWithViews
      discriminator:
        propertyName: test_case_evaluation_data_schema
        mapping:
          FLEXIBLE:
            $ref: '#/components/schemas/FlexibleTestCaseResultResponseWithViews'
          GENERATION:
            $ref: '#/components/schemas/GenerationTestCaseResultResponseWithViews'
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
          additionalProperties: true
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    GenerationTestCaseResultResponseWithViews:
      properties:
        application_test_case_output:
          $ref: '#/components/schemas/ApplicationTestCaseOutputWithTraces'
        test_case_version:
          $ref: '#/components/schemas/TestCaseVersionResponse'
        task:
          $ref: '#/components/schemas/TaskWithAssignee'
        metrics:
          title: Metrics
          additionalProperties:
            type: number
          type: object
        custom_metrics:
          title: Custom Metrics
          items:
            $ref: '#/components/schemas/MetricValueEntity'
          type: array
        audit_tasks:
          title: Audit Tasks
          items:
            $ref: '#/components/schemas/TaskWithAssignee'
          type: array
        annotation_results:
          title: Annotation Results
          items:
            $ref: '#/components/schemas/AnnotationResultExpanded'
          type: array
        label_status:
          $ref: '#/components/schemas/EvaluationORMStatusEnum'
          description: >-
            The status of the test case result. This should not be explictly set
            when creating a test case result. When patching a test case result,
            this field can be set to 'PENDING' to prevent the test case result
            from being marked 'COMPLETED'.
          optional_in_request: true
        audit_status:
          $ref: '#/components/schemas/AuditORMStatusEnum'
        audit_required:
          title: Audit Required
          type: boolean
        audit_comment:
          title: Audit Comment
          type: string
        application_spec_id:
          type: string
          title: Application Spec Id
        evaluation_id:
          type: string
          title: Evaluation Id
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
        evaluation_dataset_version_num:
          type: string
          title: Evaluation Dataset Version Num
        test_case_id:
          type: string
          title: Test Case Id
        test_case_evaluation_data:
          $ref: '#/components/schemas/ResultSchemaGeneration'
        test_case_evaluation_data_schema:
          type: string
          const: GENERATION
          title: Test Case Evaluation Data Schema
          default: GENERATION
        result:
          title: Result
          description: >-
            The result of the test case evaluation, in JSON form where the key
            is the question ID and the value is the result.
          additionalProperties:
            anyOf:
              - type: string
              - type: integer
              - type: boolean
              - type: number
              - items:
                  anyOf:
                    - type: string
                    - type: integer
                    - type: number
                    - type: boolean
                type: array
          type: object
        completed_at:
          title: Completed At
          type: string
          format: date-time
        time_spent_labeling_s:
          title: Time Spent Labeling S
          description: The time spent labeling in seconds.
          type: integer
        application_test_case_output_id:
          title: Application Test Case Output Id
          type: string
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        annotated_by_user_id:
          title: Annotated By User Id
          description: The user who annotated the task.
          type: string
        annotated_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that annotated the entity.
        edited_by_user_id:
          title: Edited By User Id
          description: The user who edited the task.
          type: string
        edited_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that edited the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
        edited_by:
          $ref: '#/components/schemas/UserV2Details'
      type: object
      required:
        - label_status
        - application_spec_id
        - evaluation_id
        - evaluation_dataset_id
        - evaluation_dataset_version_num
        - test_case_id
        - test_case_evaluation_data
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: GenerationTestCaseResultResponseWithViews
    FlexibleTestCaseResultResponseWithViews:
      properties:
        application_test_case_output:
          $ref: '#/components/schemas/ApplicationTestCaseOutputWithTraces'
        test_case_version:
          $ref: '#/components/schemas/TestCaseVersionResponse'
        task:
          $ref: '#/components/schemas/TaskWithAssignee'
        metrics:
          title: Metrics
          additionalProperties:
            type: number
          type: object
        custom_metrics:
          title: Custom Metrics
          items:
            $ref: '#/components/schemas/MetricValueEntity'
          type: array
        audit_tasks:
          title: Audit Tasks
          items:
            $ref: '#/components/schemas/TaskWithAssignee'
          type: array
        annotation_results:
          title: Annotation Results
          items:
            $ref: '#/components/schemas/AnnotationResultExpanded'
          type: array
        label_status:
          $ref: '#/components/schemas/EvaluationORMStatusEnum'
          description: >-
            The status of the test case result. This should not be explictly set
            when creating a test case result. When patching a test case result,
            this field can be set to 'PENDING' to prevent the test case result
            from being marked 'COMPLETED'.
          optional_in_request: true
        audit_status:
          $ref: '#/components/schemas/AuditORMStatusEnum'
        audit_required:
          title: Audit Required
          type: boolean
        audit_comment:
          title: Audit Comment
          type: string
        application_spec_id:
          type: string
          title: Application Spec Id
        evaluation_id:
          type: string
          title: Evaluation Id
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
        evaluation_dataset_version_num:
          type: string
          title: Evaluation Dataset Version Num
        test_case_id:
          type: string
          title: Test Case Id
        test_case_evaluation_data:
          $ref: '#/components/schemas/ResultSchemaFlexible'
        test_case_evaluation_data_schema:
          type: string
          const: FLEXIBLE
          title: Test Case Evaluation Data Schema
          default: FLEXIBLE
        result:
          title: Result
          description: >-
            The result of the test case evaluation, in JSON form where the key
            is the question ID and the value is the result.
          additionalProperties:
            anyOf:
              - type: string
              - type: integer
              - type: boolean
              - type: number
              - items:
                  anyOf:
                    - type: string
                    - type: integer
                    - type: number
                    - type: boolean
                type: array
          type: object
        completed_at:
          title: Completed At
          type: string
          format: date-time
        time_spent_labeling_s:
          title: Time Spent Labeling S
          description: The time spent labeling in seconds.
          type: integer
        application_test_case_output_id:
          title: Application Test Case Output Id
          type: string
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        annotated_by_user_id:
          title: Annotated By User Id
          description: The user who annotated the task.
          type: string
        annotated_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that annotated the entity.
        edited_by_user_id:
          title: Edited By User Id
          description: The user who edited the task.
          type: string
        edited_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that edited the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
        edited_by:
          $ref: '#/components/schemas/UserV2Details'
      type: object
      required:
        - label_status
        - application_spec_id
        - evaluation_id
        - evaluation_dataset_id
        - evaluation_dataset_version_num
        - test_case_id
        - test_case_evaluation_data
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: FlexibleTestCaseResultResponseWithViews
    ApplicationTestCaseOutputWithTraces:
      properties:
        application_variant_id:
          type: string
          title: Application Variant Id
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
        test_case_version_id:
          type: string
          title: Test Case Version Id
        test_case_id:
          type: string
          title: Test Case Id
        output:
          anyOf:
            - $ref: '#/components/schemas/ResultSchemaGeneration'
            - $ref: '#/components/schemas/ResultSchemaFlexible'
          title: Output
        schema_type:
          $ref: '#/components/schemas/EvaluationDatasetORMSchemaTypeEnum'
          can_patch: false
        application_interaction_id:
          title: Application Interaction Id
          type: string
        application_test_case_output_group_id:
          title: Application Test Case Output Group Id
          type: string
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        account_id:
          type: string
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
        interaction:
          $ref: '#/components/schemas/ApplicationInteractionWithSpansResponse'
      type: object
      required:
        - application_variant_id
        - evaluation_dataset_id
        - test_case_version_id
        - test_case_id
        - output
        - schema_type
        - id
        - created_at
        - account_id
      title: ApplicationTestCaseOutputWithTraces
    TestCaseVersionResponse:
      oneOf:
        - $ref: '#/components/schemas/GenerationTestCaseVersionResponse'
        - $ref: '#/components/schemas/FlexibleTestCaseVersionResponse'
      title: TestCaseVersionResponse
      discriminator:
        propertyName: schema_type
        mapping:
          FLEXIBLE:
            $ref: '#/components/schemas/FlexibleTestCaseVersionResponse'
          GENERATION:
            $ref: '#/components/schemas/GenerationTestCaseVersionResponse'
    TaskWithAssignee:
      properties:
        id:
          type: string
          title: Id
        task_type:
          $ref: '#/components/schemas/TaskORMTaskTypeEnum'
        task_entity_parent_id:
          type: string
          title: Task Entity Parent Id
        task_entity_id:
          type: string
          title: Task Entity Id
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          type: string
        assigned_to:
          $ref: '#/components/schemas/UserV2Details'
        assignment_expires_at:
          title: Assignment Expires At
          description: The date and time when the task assignment expires in ISO format.
          type: string
          format: date-time
        status:
          $ref: '#/components/schemas/TaskORMStatusEnum'
        priority:
          type: integer
          title: Priority
        task_entity:
          $ref: '#/components/schemas/TestCaseResultResponse'
          description: The entity that the task is associated with.
      type: object
      required:
        - id
        - task_type
        - task_entity_parent_id
        - task_entity_id
        - account_id
        - status
        - priority
      title: TaskWithAssignee
    MetricValueEntity:
      properties:
        id:
          type: string
          title: Id
        type:
          type: string
          title: Type
          description: The type of metric being measured
        name:
          type: string
          title: Name
          description: The name of the metric being measured
        output:
          type: number
          title: Output
      type: object
      required:
        - id
        - type
        - name
        - output
      title: MetricValueEntity
    AnnotationResultExpanded:
      properties:
        question_id:
          type: string
          title: Question Id
        annotation_type:
          $ref: '#/components/schemas/AnnotationType'
          description: The type of annotation result.
        test_case_result_lineage_id:
          type: string
          title: Test Case Result Lineage Id
        selected_choice:
          anyOf:
            - $ref: '#/components/schemas/CategoricalChoice'
            - items:
                $ref: '#/components/schemas/CategoricalChoice'
              type: array
            - type: integer
            - type: string
            - type: number
          title: Selected Choice
          description: >-
            The selected choices(s) for the annotation result, in JSON form. For
            categorical questions, this is an object or list of objects
            (depending on if multiple selections are allowed). For free text
            questions, this is a string. For numeric or rating questions, this
            is a number.
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        llm_auto_eval_metadata:
          $ref: '#/components/schemas/LLMAutoEvalMetadata'
      type: object
      required:
        - question_id
        - annotation_type
        - test_case_result_lineage_id
        - selected_choice
        - id
        - created_at
      title: AnnotationResultExpanded
    EvaluationORMStatusEnum:
      type: string
      enum:
        - PENDING
        - COMPLETED
        - FAILED
      title: EvaluationORMStatusEnum
    AuditORMStatusEnum:
      type: string
      enum:
        - UNAUDITED
        - FIXED
        - APPROVED
      title: AuditORMStatusEnum
    ResultSchemaGeneration:
      properties:
        generation_output:
          type: string
          title: Generation Output
        generation_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
      type: object
      required:
        - generation_output
      title: ResultSchemaGeneration
    IdentifierTypeEnum:
      type: string
      enum:
        - user
        - service_account
      title: IdentifierTypeEnum
    UserV2Details:
      properties:
        id:
          type: string
          title: Id
        first_name:
          title: First Name
          type: string
        last_name:
          title: Last Name
          type: string
        email:
          type: string
          title: Email
        preferences:
          title: Preferences
          additionalProperties: true
          type: object
      type: object
      required:
        - id
        - email
      title: UserV2Details
    ResultSchemaFlexible:
      properties:
        generation_output:
          anyOf:
            - type: string
            - additionalProperties:
                anyOf:
                  - type: string
                  - type: integer
                  - type: number
                  - items:
                      $ref: '#/components/schemas/FlexibleIOChunk'
                    type: array
                  - items:
                      $ref: '#/components/schemas/ChatMessageV2'
                    type: array
                  - items: {}
                    type: array
                  - additionalProperties: true
                    type: object
                  - $ref: '#/components/schemas/FileIODataType'
                  - type: 'null'
              type: object
          title: Generation Output
        generation_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
      type: object
      required:
        - generation_output
      title: ResultSchemaFlexible
    EvaluationDatasetORMSchemaTypeEnum:
      type: string
      enum:
        - GENERATION
        - FLEXIBLE
      title: EvaluationDatasetORMSchemaTypeEnum
    ApplicationInteractionWithSpansResponse:
      properties:
        id:
          type: string
          title: Id
        input:
          additionalProperties: true
          type: object
          title: Input
        output:
          additionalProperties: true
          type: object
          title: Output
        aggregated:
          type: boolean
          title: Aggregated
          description: >-
            Boolean of whether this interaction has been uploaded to s3 bucket
            yet, default is false
          can_patch: false
        application_spec_id:
          type: string
          title: Application Spec Id
        application_variant_id:
          type: string
          title: Application Variant Id
        start_timestamp:
          type: string
          format: date-time
          title: Start Timestamp
        duration_ms:
          type: integer
          title: Duration Ms
          description: How much time the step took in milliseconds(ms)
        operation_status:
          $ref: '#/components/schemas/ApplicationOperationStatus'
          description: The outcome of the operation
        operation_metadata:
          title: Operation Metadata
          description: >-
            The JSON representation of the metadata insights emitted through the
            execution. This can differ based on different types of operations
          additionalProperties: true
          type: object
        models:
          title: Models
          description: The models used for this interaction
          items:
            type: string
          type: array
        chat_thread_id:
          title: Chat Thread Id
          can_patch: false
          type: string
        interaction_source:
          $ref: '#/components/schemas/ApplicationInteractionSource'
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        trace_spans:
          title: Trace Spans
          items:
            $ref: '#/components/schemas/EvaluationTraceSpanResponse'
          type: array
      type: object
      required:
        - id
        - input
        - output
        - aggregated
        - application_spec_id
        - application_variant_id
        - start_timestamp
        - duration_ms
        - operation_status
        - created_at
      title: ApplicationInteractionWithSpansResponse
    GenerationTestCaseVersionResponse:
      properties:
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
          description: The ID of the associated evaluation dataset.
        schema_type:
          type: string
          const: GENERATION
          title: Schema Type
          default: GENERATION
        test_case_data:
          anyOf:
            - $ref: '#/components/schemas/ArtifactSchemaGeneration'
            - $ref: '#/components/schemas/SchemaGenerationBase'
          title: Test Case Data
        chat_history:
          title: Chat History
          description: >-
            Used for tracking previous chat interactions for multi-chat test
            cases
          additionalProperties: true
          type: object
        autogenerated:
          type: boolean
          title: Autogenerated
          description: Boolean to track whether or not the test case is autogenerated
          can_patch: false
        test_case_metadata:
          title: Test Case Metadata
          description: Metadata for the test case
          additionalProperties: true
          type: object
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
      type: object
      required:
        - evaluation_dataset_id
        - test_case_data
        - autogenerated
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: GenerationTestCaseVersionResponse
    FlexibleTestCaseVersionResponse:
      properties:
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
          description: The ID of the associated evaluation dataset.
        schema_type:
          type: string
          const: FLEXIBLE
          title: Schema Type
          default: FLEXIBLE
        test_case_data:
          $ref: '#/components/schemas/SchemaFlexible'
        chat_history:
          title: Chat History
          description: >-
            Used for tracking previous chat interactions for multi-chat test
            cases
          additionalProperties: true
          type: object
        autogenerated:
          type: boolean
          title: Autogenerated
          description: Boolean to track whether or not the test case is autogenerated
          can_patch: false
        test_case_metadata:
          title: Test Case Metadata
          description: Metadata for the test case
          additionalProperties: true
          type: object
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
      type: object
      required:
        - evaluation_dataset_id
        - test_case_data
        - autogenerated
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: FlexibleTestCaseVersionResponse
    TaskORMTaskTypeEnum:
      type: string
      enum:
        - EVALUATION_ANNOTATION
        - EVALUATION_AUDIT
        - CONTRIBUTOR_ANNOTATION
        - CONTRIBUTOR_AUDIT
      title: TaskORMTaskTypeEnum
    TaskORMStatusEnum:
      type: string
      enum:
        - NOT_READY
        - PENDING
        - PENDING_REDO
        - COMPLETED
        - FIXED
      title: TaskORMStatusEnum
    TestCaseResultResponse:
      oneOf:
        - $ref: '#/components/schemas/GenerationTestCaseResultResponse'
        - $ref: '#/components/schemas/FlexibleTestCaseResultResponse'
      title: TestCaseResultResponse
      discriminator:
        propertyName: test_case_evaluation_data_schema
        mapping:
          FLEXIBLE:
            $ref: '#/components/schemas/FlexibleTestCaseResultResponse'
          GENERATION:
            $ref: '#/components/schemas/GenerationTestCaseResultResponse'
    AnnotationType:
      type: string
      enum:
        - llm_auto
        - human
      title: AnnotationType
    CategoricalChoice:
      properties:
        label:
          title: Label
          type: string
        value:
          anyOf:
            - type: string
            - type: integer
            - type: boolean
            - type: number
          title: Value
        audit_required:
          type: boolean
          title: Audit Required
          default: false
      type: object
      required:
        - label
        - value
      title: CategoricalChoice
    LLMAutoEvalMetadata:
      properties:
        cost:
          title: Cost
          description: The cost of the annotation in cents.
          type: integer
        prompt_tokens:
          type: integer
          title: Prompt Tokens
        completion_tokens:
          type: integer
          title: Completion Tokens
        time_elapsed_s:
          type: integer
          title: Time Elapsed S
          description: The time elapsed to generate this annotation in seconds.
        llm_reasoning:
          type: string
          title: Llm Reasoning
          description: The reasoning the LLM gave for the annotation it provided.
        annotation_result_id:
          type: string
          title: Annotation Result Id
          description: The ID of the associated annotation result.
      type: object
      required:
        - prompt_tokens
        - completion_tokens
        - time_elapsed_s
        - llm_reasoning
        - annotation_result_id
      title: LLMAutoEvalMetadata
    ExtraInfoSchema:
      oneOf:
        - $ref: '#/components/schemas/ChunkExtraInfoSchema'
        - $ref: '#/components/schemas/StringExtraInfoSchema'
      title: ExtraInfoSchema
      discriminator:
        propertyName: schema_type
        mapping:
          CHUNKS:
            $ref: '#/components/schemas/ChunkExtraInfoSchema'
          STRING:
            $ref: '#/components/schemas/StringExtraInfoSchema'
    FlexibleIOChunk:
      properties:
        text:
          type: string
          title: Text
        metadata:
          title: Metadata
          additionalProperties: true
          type: object
      type: object
      required:
        - text
      title: FlexibleIOChunk
    ChatMessageV2:
      oneOf:
        - $ref: '#/components/schemas/UserMessage'
        - $ref: '#/components/schemas/AssistantMessage'
        - $ref: '#/components/schemas/SystemMessage'
      title: ChatMessageV2
      discriminator:
        propertyName: role
        mapping:
          assistant:
            $ref: '#/components/schemas/AssistantMessage'
          system:
            $ref: '#/components/schemas/SystemMessage'
          user:
            $ref: '#/components/schemas/UserMessage'
    FileIODataType:
      anyOf:
        - $ref: '#/components/schemas/ExternalFile'
        - $ref: '#/components/schemas/InternalFile'
      title: FileIODataType
    ApplicationOperationStatus:
      type: string
      enum:
        - SUCCESS
        - ERROR
        - CANCELED
      title: ApplicationOperationStatus
    ApplicationInteractionSource:
      type: string
      enum:
        - EXTERNAL_AI
        - EVALUATION
        - SGP_CHAT
        - AGENTS_SERVICE
      title: ApplicationInteractionSource
    EvaluationTraceSpanResponse:
      properties:
        id:
          type: string
          title: Id
          description: Identifies the application step
        application_interaction_id:
          title: Application Interaction Id
          description: The interaction ID this span belongs to
          type: string
        application_variant_id:
          title: Application Variant Id
          description: The id of the application variant this span belongs to
          type: string
        node_id:
          type: string
          title: Node Id
          description: >-
            The id of the node in the application_variant config that emitted
            this insight
        operation_type:
          $ref: '#/components/schemas/ApplicationOperationType'
          description: Type of the operation, e.g. RERANKING
        operation_status:
          $ref: '#/components/schemas/ApplicationOperationStatus'
          description: The outcome of the operation
        operation_input:
          $ref: '#/components/schemas/EvaluationSpanIOData'
          description: The JSON representation of the input that this step received.
        operation_output:
          $ref: '#/components/schemas/EvaluationSpanIOData'
          description: The JSON representation of the output that this step emitted.
        operation_expected:
          $ref: '#/components/schemas/EvaluationSpanIOData'
          description: The JSON representation of the expected output for this step
        operation_metadata:
          title: Operation Metadata
          description: >-
            The JSON representation of the metadata insights emitted through the
            execution. This can differ based on different types of operations
          additionalProperties: true
          type: object
        start_timestamp:
          type: string
          format: date-time
          title: Start Timestamp
          description: The start time of the step
        end_timestamp:
          title: End Timestamp
          description: >-
            The end time of the step, nullable, since it can be set to done at a
            later point in time.
          type: string
          format: date-time
        duration_ms:
          type: integer
          title: Duration Ms
          description: How much time the step took in milliseconds(ms)
        trace_id:
          title: Trace Id
          description: The root-level ID where this span belongs to
          type: string
        parent_id:
          title: Parent Id
          description: >-
            Who is the parent span of this current span, null if span is root
            parent.
          type: string
        group_id:
          title: Group Id
          description: The ID of the group this span belongs to
          type: string
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
      type: object
      required:
        - id
        - node_id
        - operation_type
        - operation_status
        - operation_input
        - operation_output
        - start_timestamp
        - duration_ms
      title: EvaluationTraceSpanResponse
    ArtifactSchemaGeneration:
      properties:
        input:
          type: string
          title: Input
        expected_output:
          title: Expected Output
          type: string
        expected_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
        artifact_ids_filter:
          items:
            type: string
          type: array
          title: Artifact Ids Filter
      type: object
      required:
        - input
        - artifact_ids_filter
      title: ArtifactSchemaGeneration
    SchemaGenerationBase:
      properties:
        input:
          type: string
          title: Input
        expected_output:
          title: Expected Output
          type: string
        expected_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
      type: object
      required:
        - input
      title: SchemaGenerationBase
    SchemaFlexible:
      properties:
        input:
          anyOf:
            - type: string
            - additionalProperties:
                anyOf:
                  - type: string
                  - type: integer
                  - type: number
                  - items:
                      $ref: '#/components/schemas/FlexibleIOChunk'
                    type: array
                  - items:
                      $ref: '#/components/schemas/ChatMessageV2'
                    type: array
                  - items: {}
                    type: array
                  - additionalProperties: true
                    type: object
                  - $ref: '#/components/schemas/FileIODataType'
                  - type: 'null'
              type: object
          title: Input
        expected_output:
          anyOf:
            - type: string
            - additionalProperties:
                anyOf:
                  - type: string
                  - type: integer
                  - type: number
                  - items:
                      $ref: '#/components/schemas/FlexibleIOChunk'
                    type: array
                  - items:
                      $ref: '#/components/schemas/ChatMessageV2'
                    type: array
                  - items: {}
                    type: array
                  - additionalProperties: true
                    type: object
                  - $ref: '#/components/schemas/FileIODataType'
                  - type: 'null'
              type: object
          title: Expected Output
        expected_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
      type: object
      required:
        - input
      title: SchemaFlexible
    GenerationTestCaseResultResponse:
      properties:
        label_status:
          $ref: '#/components/schemas/EvaluationORMStatusEnum'
          description: >-
            The status of the test case result. This should not be explictly set
            when creating a test case result. When patching a test case result,
            this field can be set to 'PENDING' to prevent the test case result
            from being marked 'COMPLETED'.
          optional_in_request: true
        audit_status:
          $ref: '#/components/schemas/AuditORMStatusEnum'
        audit_required:
          title: Audit Required
          type: boolean
        audit_comment:
          title: Audit Comment
          type: string
        application_spec_id:
          type: string
          title: Application Spec Id
        evaluation_id:
          type: string
          title: Evaluation Id
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
        evaluation_dataset_version_num:
          type: string
          title: Evaluation Dataset Version Num
        test_case_id:
          type: string
          title: Test Case Id
        test_case_evaluation_data:
          $ref: '#/components/schemas/ResultSchemaGeneration'
        test_case_evaluation_data_schema:
          type: string
          const: GENERATION
          title: Test Case Evaluation Data Schema
          default: GENERATION
        result:
          title: Result
          description: >-
            The result of the test case evaluation, in JSON form where the key
            is the question ID and the value is the result.
          additionalProperties:
            anyOf:
              - type: string
              - type: integer
              - type: boolean
              - type: number
              - items:
                  anyOf:
                    - type: string
                    - type: integer
                    - type: number
                    - type: boolean
                type: array
          type: object
        completed_at:
          title: Completed At
          type: string
          format: date-time
        time_spent_labeling_s:
          title: Time Spent Labeling S
          description: The time spent labeling in seconds.
          type: integer
        application_test_case_output_id:
          title: Application Test Case Output Id
          type: string
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        annotated_by_user_id:
          title: Annotated By User Id
          description: The user who annotated the task.
          type: string
        annotated_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that annotated the entity.
        edited_by_user_id:
          title: Edited By User Id
          description: The user who edited the task.
          type: string
        edited_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that edited the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
        edited_by:
          $ref: '#/components/schemas/UserV2Details'
      type: object
      required:
        - label_status
        - application_spec_id
        - evaluation_id
        - evaluation_dataset_id
        - evaluation_dataset_version_num
        - test_case_id
        - test_case_evaluation_data
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: GenerationTestCaseResultResponse
    FlexibleTestCaseResultResponse:
      properties:
        label_status:
          $ref: '#/components/schemas/EvaluationORMStatusEnum'
          description: >-
            The status of the test case result. This should not be explictly set
            when creating a test case result. When patching a test case result,
            this field can be set to 'PENDING' to prevent the test case result
            from being marked 'COMPLETED'.
          optional_in_request: true
        audit_status:
          $ref: '#/components/schemas/AuditORMStatusEnum'
        audit_required:
          title: Audit Required
          type: boolean
        audit_comment:
          title: Audit Comment
          type: string
        application_spec_id:
          type: string
          title: Application Spec Id
        evaluation_id:
          type: string
          title: Evaluation Id
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
        evaluation_dataset_version_num:
          type: string
          title: Evaluation Dataset Version Num
        test_case_id:
          type: string
          title: Test Case Id
        test_case_evaluation_data:
          $ref: '#/components/schemas/ResultSchemaFlexible'
        test_case_evaluation_data_schema:
          type: string
          const: FLEXIBLE
          title: Test Case Evaluation Data Schema
          default: FLEXIBLE
        result:
          title: Result
          description: >-
            The result of the test case evaluation, in JSON form where the key
            is the question ID and the value is the result.
          additionalProperties:
            anyOf:
              - type: string
              - type: integer
              - type: boolean
              - type: number
              - items:
                  anyOf:
                    - type: string
                    - type: integer
                    - type: number
                    - type: boolean
                type: array
          type: object
        completed_at:
          title: Completed At
          type: string
          format: date-time
        time_spent_labeling_s:
          title: Time Spent Labeling S
          description: The time spent labeling in seconds.
          type: integer
        application_test_case_output_id:
          title: Application Test Case Output Id
          type: string
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        annotated_by_user_id:
          title: Annotated By User Id
          description: The user who annotated the task.
          type: string
        annotated_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that annotated the entity.
        edited_by_user_id:
          title: Edited By User Id
          description: The user who edited the task.
          type: string
        edited_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that edited the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
        edited_by:
          $ref: '#/components/schemas/UserV2Details'
      type: object
      required:
        - label_status
        - application_spec_id
        - evaluation_id
        - evaluation_dataset_id
        - evaluation_dataset_version_num
        - test_case_id
        - test_case_evaluation_data
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: FlexibleTestCaseResultResponse
    ChunkExtraInfoSchema:
      properties:
        schema_type:
          type: string
          const: CHUNKS
          title: Schema Type
          default: CHUNKS
        chunks:
          items:
            $ref: '#/components/schemas/ChunkData'
          type: array
          title: Chunks
      type: object
      required:
        - chunks
      title: ChunkExtraInfoSchema
    StringExtraInfoSchema:
      properties:
        schema_type:
          type: string
          const: STRING
          title: Schema Type
          default: STRING
        info:
          type: string
          title: Info
      type: object
      required:
        - info
      title: StringExtraInfoSchema
    UserMessage:
      properties:
        role:
          type: string
          const: user
          title: Role
          description: >-
            The role of the message. Must be set to 'user'.


            A user message is a message from the user to the AI. This should be
            the message used to send end user input to the AI.
          default: user
        content:
          anyOf:
            - type: string
            - items:
                $ref: '#/components/schemas/UserMessageContentParts'
              type: array
          title: Content
          description: >-
            Input from the user. Can either be text or a list of content parts.
            Not all models support image content parts, or multiple parts.
      type: object
      required:
        - content
      title: User Message
    AssistantMessage:
      properties:
        role:
          type: string
          const: assistant
          title: Role
          description: >-
            The role of the message. Must be set to 'assistant'.


            An assistant message is a message from the AI to the client. It is
            different from an agent message in that it cannot contain a tool
            request. It is simply a direct response from the AI to the client.
          default: assistant
        content:
          type: string
          title: Content
          description: Text response from the assistant
      type: object
      required:
        - content
      title: Assistant Message
    SystemMessage:
      properties:
        role:
          type: string
          const: system
          title: Role
          description: >-
            The role of the message. Must be set to 'system'.


            A system message is different from other messages in that it does
            not originate from a party engaged in a user/AI conversation.
            Instead, it is a message that is injected by either the application
            or system to guide the conversation. For example, a system message
            may be used as initial instructions for an AI entity or to tell the
            AI that it did not do something correctly.
          default: system
        content:
          type: string
          title: Content
          description: Text input from the system.
      type: object
      required:
        - content
      title: System Message
    ExternalFile:
      properties:
        uri:
          type: string
          title: Uri
        file_type:
          type: string
          enum:
            - image
            - pdf
          title: File Type
      type: object
      required:
        - uri
        - file_type
      title: ExternalFile
    InternalFile:
      properties:
        file_id:
          type: string
          title: File Id
        file_type:
          type: string
          enum:
            - image
            - pdf
          title: File Type
      type: object
      required:
        - file_id
        - file_type
      title: InternalFile
    ApplicationOperationType:
      type: string
      enum:
        - TEXT_INPUT
        - TEXT_OUTPUT
        - COMPLETION_INPUT
        - COMPLETION
        - KB_RETRIEVAL
        - KB_INPUT
        - RERANKING
        - EXTERNAL_ENDPOINT
        - PROMPT_ENGINEERING
        - DOCUMENT_INPUT
        - MAP_REDUCE
        - DOCUMENT_SEARCH
        - DOCUMENT_PROMPT
        - CUSTOM
        - CODE_EXECUTION
        - DATA_MANIPULATION
        - EVALUATION
        - FILE_RETRIEVAL
        - KB_ADD_CHUNK
        - KB_MANAGEMENT
        - GUARDRAIL
        - OUTPUT_GUARDRAIL
        - TRACER
        - AGENT_TRACER
        - AGENT_WORKFLOW
        - STANDALONE
      title: ApplicationOperationType
    EvaluationSpanIOData:
      additionalProperties:
        anyOf:
          - type: string
          - type: integer
          - type: number
          - items:
              $ref: '#/components/schemas/FlexibleIOChunk'
            type: array
          - items:
              $ref: '#/components/schemas/ChatMessageV2'
            type: array
          - items: {}
            type: array
          - additionalProperties: true
            type: object
          - $ref: '#/components/schemas/FileIODataType'
          - type: 'null'
      type: object
      title: EvaluationSpanIOData
    ChunkData:
      properties:
        text:
          type: string
          title: Text
        metadata:
          title: Metadata
          additionalProperties: true
          type: object
      type: object
      required:
        - text
      title: ChunkData
    UserMessageContentParts:
      oneOf:
        - $ref: '#/components/schemas/TextUserMessageContentParts'
        - $ref: '#/components/schemas/ImageUrlUserMessageContentParts'
        - $ref: '#/components/schemas/ImageDataUserMessageContentParts'
      title: UserMessageContentParts
      discriminator:
        propertyName: type
        mapping:
          image_data:
            $ref: '#/components/schemas/ImageDataUserMessageContentParts'
          image_url:
            $ref: '#/components/schemas/ImageUrlUserMessageContentParts'
          text:
            $ref: '#/components/schemas/TextUserMessageContentParts'
    TextUserMessageContentParts:
      properties:
        type:
          type: string
          const: text
          title: Type
          default: text
        text:
          type: string
          title: Text
      type: object
      required:
        - text
      title: TextUserMessageContentParts
    ImageUrlUserMessageContentParts:
      properties:
        type:
          type: string
          const: image_url
          title: Type
          default: image_url
        image_url:
          $ref: '#/components/schemas/ImageUrlSubPart'
          description: >-
            Specifies the image URL and level of detail. Only supported by
            OpenAI models
      type: object
      required:
        - image_url
      title: ImageUrlUserMessageContentParts
    ImageDataUserMessageContentParts:
      properties:
        type:
          type: string
          const: image_data
          title: Type
          default: image_data
        image_data:
          $ref: '#/components/schemas/ImageDataSubPart'
          description: Specifies inline image data
      type: object
      required:
        - image_data
      title: ImageDataUserMessageContentParts
    ImageUrlSubPart:
      properties:
        url:
          type: string
          title: Url
          description: 'The URL of the image. Note: only OpenAI supports this.'
        detail:
          title: Detail
          description: >-
            Only used for OpenAI. Corresponds to OpenAI's image detail
            parameter.
          type: string
          enum:
            - low
            - high
            - auto
      type: object
      required:
        - url
      title: ImageUrlSubPart
    ImageDataSubPart:
      properties:
        type:
          type: string
          const: base64
          title: Type
          description: The type of the image data. Only base64 is supported.
          default: base64
        media_type:
          type: string
          title: Media Type
          description: >-
            The media/mime type of the image data. For example, 'image/png'.
            Check providers' documentation for supported media types.
        data:
          type: string
          title: Data
          description: The base64-encoded image data.
        detail:
          title: Detail
          description: >-
            Only used for OpenAI. Corresponds to OpenAI's image detail
            parameter.
          type: string
          enum:
            - low
            - high
            - auto
      type: object
      required:
        - media_type
        - data
      title: ImageDataSubPart

````